66-shutdownd(8)

# NAME

66-shutdownd - The daemon that manages the shutdown procedure for *66-boot*(8)

# SYNOPSIS

66-shutdownd [ *-h* ] [ *-l* _live_ ] [ *-s* _skel_ ] [ *-g* _gracetime_ ]

# DESCRIPTION

It is not meant to be called directly by the user. This program is a modified copy of *s6-linux-init-shudownd* program.

- *66-shutdownd* opens the _live_/scandir/0/shutdownd/fifo pipe and listens to
  it. This is where programs such as *66-shutdown*(8) send their commands when
  they are told to trigger the shutdown procedure.

- When it receives a command to shut down, *66-shutdownd* parses the _skel_
  file _rc.init_ define by default at *%%sysconfdir%%* directory and reads the
  value of *RCSHUTDOWN* variable to be able to spawns the _rc.shutdown_ script.

- When said script exits, *66-shutdownd* kills all processes with a
  SIGTERM first, and, after the grace time specified by the shutdown command
  with a SIGKILL.

- It then runs an automatically generated script called _stage4_, which
  unmounts the file systems and halts, powers off or reboots the machine.

# OPTIONS

*-h*
	Prints this help.

*-l* _live_
	An abdolute path. Directory to use. By default *66-shutdownd* will listen
	to signals from *66-shutdown*(8) service at
	_live_/scandir/0/shutdownd/fifo. Where _live_ default to *%%livedir%%*. Can
	also be changed at compile-time by passing the --livedir=_live_ option to
	*./configure*. Should be under a writable filesystem - likely a RAM
	filesystem.

*-s* _skel_
	An abdolute path. Directory of the skeleton file _rc.init_. Default is
	*%%sysconfdir%%*.

*-g* _gracetime_
	Specify a grace time between the SIGTERM and the SIGKILLin milliseconds if
	the shutdown command does not provide one. Default is 3000.

# NOTES

The *66-shutdownd* binary is not meant to be called directly.
It is automatically generated by a *66-scandir*(1) program invocation.
